Subject: bug#3325: 23.0.93; Unexpected font for composed character

From: Kenichi Handa <[email-masked]>
Date: Tue, 19 May 2009 09:54:49 +0900

In article <[email-masked]>, Markus Triska <[email-masked]> writes:

> I have a file ~/Downloads/Büroanwendungen.zip. When I visit ~/Downloads/
> in dired (C-x d ~/Downloads/ RET) and press C-u x = on the "ü", I get:

>            character: u (117, #o165, #x75)
>    preferred charset: ascii (ASCII (ISO646 IRV))
>           code point: 0x75
>               syntax: w 	which means: word
>             category: .:Base, a:ASCII, l:Latin, r:Roman
>          buffer code: #x75
>            file code: #x75 (encoded by coding system utf-8-unix)
>              display: composed to form "ü" (see below)

>    Composed with the following character(s) "̈" using this font:
>      xft:-itc-American Typewriter-normal-normal-normal-*-20-*-*-*-*-0-iso10646-1
[...]
> This font differs unexpectedly (for me) from the one used for the "r":
[...]
>        xft:-bitstream-Bitstream Vera Sans Mono-normal-normal-normal-*-20-*-*-*-m-0-iso10646-1 (#x55)

In your file, `ü" is acually not a signle character but two
characters `u' and U+308 (COMBINING DIAERESIS), and it seems
that the above bitstream font doesn't contain a glyph of
U+308.  So, Emacs searches for a font that has that glyph.
The found font in your case was "American Typewriter".

It may be good that Emacs knows that `u'+U+308 = `ü', but
that kind of normalization is not yet supported.

---
Kenichi Handa
[email-masked]